// on my linux box. (2.6.12-10-amd64-k8-smp)
//g++ -o tst-cat -lxml2 -I/usr/include/libxml2 test-xml2-catatlog.cc

// on sgi (IRIX64 muse 6.5 04100803 IP35)
//CC -LANG:std test-xml2-catatlog.cc -o tst-cat -Wl,-rpath -Wl,/home/sci/mjc/libxml2_installed/lib -L /home/sci/mjc/libxml2_installed/lib -lxml2 -lz -lpthread -lm -I/home/sci/mjc/libxml2_installed/include/libxml2

#include <stdio.h>
#include <stdlib.h>

#include <iostream>
#include <sstream>

#include <libxml/xmlreader.h>
#include <libxml/catalog.h>

using namespace std;

void usage();

int
main( int argc, char *argv[] )
{
  if( argc != 2 ) {
    printf("\n");
    printf("Error, bad number of arguments...\n");
    usage();
  }

  /*
   * this initialize the library and check potential ABI mismatches
   * between the version it was compiled for and the actual shared
   * library used.
   */
  LIBXML_TEST_VERSION;

  xmlParserCtxtPtr ctxt; /* the parser context */
  xmlDocPtr doc; /* the resulting document tree */

  char* dtdpath = getenv("PATH_TO_DTD");
  if (dtdpath == 0) {
    cerr << "Please set PATH_TO_DTD in your environment variables" << endl;
    exit(1);
  }

  ostringstream dtdstr;

  dtdstr << dtdpath << "/network.dtd";

  string public_scirun_net_dtd = "-//SCIRun/Network DTD";

  
  cerr << "Setting the catalog path for : " << public_scirun_net_dtd 
       << " to : " << dtdstr.str() << endl;

  xmlInitializeCatalog();
  xmlCatalogAdd(BAD_CAST "public", BAD_CAST public_scirun_net_dtd.c_str(), 
		BAD_CAST dtdstr.str().c_str());

  /* create a parser context */
  ctxt = xmlNewParserCtxt();
  if (ctxt == 0) {
    std::cerr << "ComponentNode.cc: Failed to allocate parser context\n";
    return -1;
  }
  /* parse the file, activating the DTD validation option */
  doc = xmlCtxtReadFile( ctxt, argv[1], 0, (XML_PARSE_DTDATTR | 
                                            XML_PARSE_DTDVALID) );
  return 0;
}


void 
usage()
{
  printf("\n");
  printf("Usage: validateXML <filename.xml>\n");
  printf("\n");
  exit( 1 );
}
